/* TabbedWebView.c generated by valac 0.56.18, the Vala compiler
 * generated from TabbedWebView.vala, do not modify */

/*
* Copyright 2016-2023 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <webkit/webkit.h>
#include <glib-object.h>
#include <glib.h>
#include <gcr/gcr.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CAPTIVE_TYPE_TABBED_WEB_VIEW (captive_tabbed_web_view_get_type ())
#define CAPTIVE_TABBED_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAPTIVE_TYPE_TABBED_WEB_VIEW, CaptiveTabbedWebView))
#define CAPTIVE_TABBED_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAPTIVE_TYPE_TABBED_WEB_VIEW, CaptiveTabbedWebViewClass))
#define CAPTIVE_IS_TABBED_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAPTIVE_TYPE_TABBED_WEB_VIEW))
#define CAPTIVE_IS_TABBED_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAPTIVE_TYPE_TABBED_WEB_VIEW))
#define CAPTIVE_TABBED_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAPTIVE_TYPE_TABBED_WEB_VIEW, CaptiveTabbedWebViewClass))

typedef struct _CaptiveTabbedWebView CaptiveTabbedWebView;
typedef struct _CaptiveTabbedWebViewClass CaptiveTabbedWebViewClass;
typedef struct _CaptiveTabbedWebViewPrivate CaptiveTabbedWebViewPrivate;
typedef enum  {
	CAPTIVE_TABBED_WEB_VIEW_SECURITY_NONE,
	CAPTIVE_TABBED_WEB_VIEW_SECURITY_SECURE,
	CAPTIVE_TABBED_WEB_VIEW_SECURITY_LOADING,
	CAPTIVE_TABBED_WEB_VIEW_SECURITY_MIXED_CONTENT
} CaptiveTabbedWebViewSecurity;

#define CAPTIVE_TABBED_WEB_VIEW_TYPE_SECURITY (captive_tabbed_web_view_security_get_type ())
enum  {
	CAPTIVE_TABBED_WEB_VIEW_0_PROPERTY,
	CAPTIVE_TABBED_WEB_VIEW_LOAD_COOKIES_PROPERTY,
	CAPTIVE_TABBED_WEB_VIEW_SECURITY_PROPERTY,
	CAPTIVE_TABBED_WEB_VIEW_CERTIFICATE_PROPERTY,
	CAPTIVE_TABBED_WEB_VIEW_NUM_PROPERTIES
};
static GParamSpec* captive_tabbed_web_view_properties[CAPTIVE_TABBED_WEB_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CaptiveTabbedWebView {
	WebKitWebView parent_instance;
	CaptiveTabbedWebViewPrivate * priv;
};

struct _CaptiveTabbedWebViewClass {
	WebKitWebViewClass parent_class;
};

struct _CaptiveTabbedWebViewPrivate {
	gboolean _load_cookies;
	CaptiveTabbedWebViewSecurity _security;
	GcrSimpleCertificate* _certificate;
};

static gint CaptiveTabbedWebView_private_offset;
static gpointer captive_tabbed_web_view_parent_class = NULL;

VALA_EXTERN GType captive_tabbed_web_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CaptiveTabbedWebView, g_object_unref)
VALA_EXTERN GType captive_tabbed_web_view_security_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* captive_tabbed_web_view_security_to_icon_name (CaptiveTabbedWebViewSecurity self);
VALA_EXTERN CaptiveTabbedWebView* captive_tabbed_web_view_new (gboolean load_cookies);
VALA_EXTERN CaptiveTabbedWebView* captive_tabbed_web_view_construct (GType object_type,
                                                         gboolean load_cookies);
VALA_EXTERN gchar* captive_tabbed_web_view_security_to_string (CaptiveTabbedWebView* self);
VALA_EXTERN CaptiveTabbedWebViewSecurity captive_tabbed_web_view_get_security (CaptiveTabbedWebView* self);
static void captive_tabbed_web_view_update_tls_info (CaptiveTabbedWebView* self);
static void captive_tabbed_web_view_set_certificate (CaptiveTabbedWebView* self,
                                              GcrSimpleCertificate* value);
static void captive_tabbed_web_view_set_security (CaptiveTabbedWebView* self,
                                           CaptiveTabbedWebViewSecurity value);
VALA_EXTERN gboolean captive_tabbed_web_view_get_load_cookies (CaptiveTabbedWebView* self);
static void captive_tabbed_web_view_set_load_cookies (CaptiveTabbedWebView* self,
                                               gboolean value);
VALA_EXTERN GcrSimpleCertificate* captive_tabbed_web_view_get_certificate (CaptiveTabbedWebView* self);
static GObject * captive_tabbed_web_view_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _captive_tabbed_web_view___lambda4_ (CaptiveTabbedWebView* self);
static void __captive_tabbed_web_view___lambda4__webkit_web_view_insecure_content_detected (WebKitWebView* _sender,
                                                                                     WebKitInsecureContentEvent event,
                                                                                     gpointer self);
static void _captive_tabbed_web_view___lambda5_ (CaptiveTabbedWebView* self,
                                          WebKitWebView* view,
                                          WebKitLoadEvent event);
static void __captive_tabbed_web_view___lambda5__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                        WebKitLoadEvent load_event,
                                                                        gpointer self);
static void captive_tabbed_web_view_finalize (GObject * obj);
static GType captive_tabbed_web_view_get_type_once (void);
static void _vala_captive_tabbed_web_view_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_captive_tabbed_web_view_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
captive_tabbed_web_view_get_instance_private (CaptiveTabbedWebView* self)
{
	return G_STRUCT_MEMBER_P (self, CaptiveTabbedWebView_private_offset);
}

gchar*
captive_tabbed_web_view_security_to_icon_name (CaptiveTabbedWebViewSecurity self)
{
	gchar* result;
#line 33 "../src/TabbedWebView.vala"
	switch (self) {
#line 33 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_NONE:
#line 157 "TabbedWebView.c"
		{
			gchar* _tmp0_;
#line 35 "../src/TabbedWebView.vala"
			_tmp0_ = g_strdup ("security-low-symbolic");
#line 35 "../src/TabbedWebView.vala"
			result = _tmp0_;
#line 35 "../src/TabbedWebView.vala"
			return result;
#line 166 "TabbedWebView.c"
		}
#line 33 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_SECURE:
#line 170 "TabbedWebView.c"
		{
			gchar* _tmp1_;
#line 38 "../src/TabbedWebView.vala"
			_tmp1_ = g_strdup ("security-high-symbolic");
#line 38 "../src/TabbedWebView.vala"
			result = _tmp1_;
#line 38 "../src/TabbedWebView.vala"
			return result;
#line 179 "TabbedWebView.c"
		}
#line 33 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_MIXED_CONTENT:
#line 183 "TabbedWebView.c"
		{
			gchar* _tmp2_;
#line 41 "../src/TabbedWebView.vala"
			_tmp2_ = g_strdup ("security-medium-symbolic");
#line 41 "../src/TabbedWebView.vala"
			result = _tmp2_;
#line 41 "../src/TabbedWebView.vala"
			return result;
#line 192 "TabbedWebView.c"
		}
		default:
#line 33 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_LOADING:
#line 197 "TabbedWebView.c"
		{
			gchar* _tmp3_;
#line 45 "../src/TabbedWebView.vala"
			_tmp3_ = g_strdup ("content-loading-symbolic");
#line 45 "../src/TabbedWebView.vala"
			result = _tmp3_;
#line 45 "../src/TabbedWebView.vala"
			return result;
#line 206 "TabbedWebView.c"
		}
	}
}

static GType
captive_tabbed_web_view_security_get_type_once (void)
{
	static const GEnumValue values[] = {{CAPTIVE_TABBED_WEB_VIEW_SECURITY_NONE, "CAPTIVE_TABBED_WEB_VIEW_SECURITY_NONE", "none"}, {CAPTIVE_TABBED_WEB_VIEW_SECURITY_SECURE, "CAPTIVE_TABBED_WEB_VIEW_SECURITY_SECURE", "secure"}, {CAPTIVE_TABBED_WEB_VIEW_SECURITY_LOADING, "CAPTIVE_TABBED_WEB_VIEW_SECURITY_LOADING", "loading"}, {CAPTIVE_TABBED_WEB_VIEW_SECURITY_MIXED_CONTENT, "CAPTIVE_TABBED_WEB_VIEW_SECURITY_MIXED_CONTENT", "mixed-content"}, {0, NULL, NULL}};
	GType captive_tabbed_web_view_security_type_id;
	captive_tabbed_web_view_security_type_id = g_enum_register_static ("CaptiveTabbedWebViewSecurity", values);
	return captive_tabbed_web_view_security_type_id;
}

GType
captive_tabbed_web_view_security_get_type (void)
{
	static volatile gsize captive_tabbed_web_view_security_type_id__once = 0;
	if (g_once_init_enter (&captive_tabbed_web_view_security_type_id__once)) {
		GType captive_tabbed_web_view_security_type_id;
		captive_tabbed_web_view_security_type_id = captive_tabbed_web_view_security_get_type_once ();
		g_once_init_leave (&captive_tabbed_web_view_security_type_id__once, captive_tabbed_web_view_security_type_id);
	}
	return captive_tabbed_web_view_security_type_id__once;
}

CaptiveTabbedWebView*
captive_tabbed_web_view_construct (GType object_type,
                                   gboolean load_cookies)
{
	CaptiveTabbedWebView * self = NULL;
#line 51 "../src/TabbedWebView.vala"
	self = (CaptiveTabbedWebView*) g_object_new (object_type, "load-cookies", load_cookies, NULL);
#line 50 "../src/TabbedWebView.vala"
	return self;
#line 241 "TabbedWebView.c"
}

CaptiveTabbedWebView*
captive_tabbed_web_view_new (gboolean load_cookies)
{
#line 50 "../src/TabbedWebView.vala"
	return captive_tabbed_web_view_construct (CAPTIVE_TYPE_TABBED_WEB_VIEW, load_cookies);
#line 249 "TabbedWebView.c"
}

gchar*
captive_tabbed_web_view_security_to_string (CaptiveTabbedWebView* self)
{
	CaptiveTabbedWebViewSecurity _tmp0_;
	gchar* result;
#line 89 "../src/TabbedWebView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/TabbedWebView.vala"
	_tmp0_ = self->priv->_security;
#line 90 "../src/TabbedWebView.vala"
	switch (_tmp0_) {
#line 90 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_NONE:
#line 265 "TabbedWebView.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 92 "../src/TabbedWebView.vala"
			_tmp1_ = webkit_web_view_get_uri ((WebKitWebView*) self);
#line 92 "../src/TabbedWebView.vala"
			_tmp2_ = g_strdup_printf (_ ("“%s” is served over an unprotected connection"), _tmp1_);
#line 92 "../src/TabbedWebView.vala"
			result = _tmp2_;
#line 92 "../src/TabbedWebView.vala"
			return result;
#line 277 "TabbedWebView.c"
		}
#line 90 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_SECURE:
#line 281 "TabbedWebView.c"
		{
			const gchar* _tmp3_;
			gchar* _tmp4_;
#line 95 "../src/TabbedWebView.vala"
			_tmp3_ = webkit_web_view_get_uri ((WebKitWebView*) self);
#line 95 "../src/TabbedWebView.vala"
			_tmp4_ = g_strdup_printf (_ ("“%s” is served over a protected connection"), _tmp3_);
#line 95 "../src/TabbedWebView.vala"
			result = _tmp4_;
#line 95 "../src/TabbedWebView.vala"
			return result;
#line 293 "TabbedWebView.c"
		}
#line 90 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_MIXED_CONTENT:
#line 297 "TabbedWebView.c"
		{
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 98 "../src/TabbedWebView.vala"
			_tmp5_ = webkit_web_view_get_uri ((WebKitWebView*) self);
#line 98 "../src/TabbedWebView.vala"
			_tmp6_ = g_strdup_printf (_ ("Some elements of “%s” are served over an unprotected connection"), _tmp5_);
#line 98 "../src/TabbedWebView.vala"
			result = _tmp6_;
#line 98 "../src/TabbedWebView.vala"
			return result;
#line 309 "TabbedWebView.c"
		}
		default:
#line 90 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_LOADING:
#line 314 "TabbedWebView.c"
		{
			gchar* _tmp7_;
#line 102 "../src/TabbedWebView.vala"
			_tmp7_ = g_strdup (_ ("Loading captive portal"));
#line 102 "../src/TabbedWebView.vala"
			result = _tmp7_;
#line 102 "../src/TabbedWebView.vala"
			return result;
#line 323 "TabbedWebView.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "../src/TabbedWebView.vala"
	return self ? g_object_ref (self) : NULL;
#line 333 "TabbedWebView.c"
}

static void
captive_tabbed_web_view_update_tls_info (CaptiveTabbedWebView* self)
{
	GTlsCertificate* cert = NULL;
	GTlsCertificateFlags cert_flags = 0U;
	gboolean is_secure = FALSE;
	GTlsCertificate* _tmp0_ = NULL;
	GTlsCertificateFlags _tmp1_ = 0U;
	gboolean _tmp2_;
	GTlsCertificate* _tmp3_;
#line 106 "../src/TabbedWebView.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/TabbedWebView.vala"
	_tmp2_ = webkit_web_view_get_tls_info ((WebKitWebView*) self, &_tmp0_, &_tmp1_);
#line 111 "../src/TabbedWebView.vala"
	_g_object_unref0 (cert);
#line 111 "../src/TabbedWebView.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 111 "../src/TabbedWebView.vala"
	cert = _tmp3_;
#line 111 "../src/TabbedWebView.vala"
	cert_flags = _tmp1_;
#line 111 "../src/TabbedWebView.vala"
	if (!_tmp2_) {
#line 113 "../src/TabbedWebView.vala"
		is_secure = FALSE;
#line 114 "../src/TabbedWebView.vala"
		captive_tabbed_web_view_set_certificate (self, NULL);
#line 364 "TabbedWebView.c"
	} else {
		GTlsCertificate* _tmp4_;
		GByteArray* _tmp5_;
		GByteArray* _tmp6_;
		GByteArray* _tmp7_;
		guint8* _tmp8_;
		gint _tmp8__length1;
		GcrSimpleCertificate* _tmp9_;
		GcrSimpleCertificate* _tmp10_;
#line 118 "../src/TabbedWebView.vala"
		is_secure = cert_flags == 0;
#line 119 "../src/TabbedWebView.vala"
		_tmp4_ = cert;
#line 119 "../src/TabbedWebView.vala"
		g_object_get (_tmp4_, "certificate", &_tmp5_, NULL);
#line 119 "../src/TabbedWebView.vala"
		_tmp6_ = _tmp5_;
#line 119 "../src/TabbedWebView.vala"
		_tmp7_ = _tmp6_;
#line 119 "../src/TabbedWebView.vala"
		_tmp8_ = _tmp7_->data;
#line 119 "../src/TabbedWebView.vala"
		_tmp8__length1 = _tmp7_->len;
#line 119 "../src/TabbedWebView.vala"
		_tmp9_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp8_, _tmp8__length1);
#line 119 "../src/TabbedWebView.vala"
		_tmp10_ = _tmp9_;
#line 119 "../src/TabbedWebView.vala"
		captive_tabbed_web_view_set_certificate (self, _tmp10_);
#line 119 "../src/TabbedWebView.vala"
		_g_object_unref0 (_tmp10_);
#line 119 "../src/TabbedWebView.vala"
		_g_byte_array_unref0 (_tmp7_);
#line 398 "TabbedWebView.c"
	}
#line 122 "../src/TabbedWebView.vala"
	if (is_secure) {
#line 123 "../src/TabbedWebView.vala"
		captive_tabbed_web_view_set_security (self, CAPTIVE_TABBED_WEB_VIEW_SECURITY_SECURE);
#line 404 "TabbedWebView.c"
	} else {
#line 125 "../src/TabbedWebView.vala"
		captive_tabbed_web_view_set_security (self, CAPTIVE_TABBED_WEB_VIEW_SECURITY_NONE);
#line 408 "TabbedWebView.c"
	}
#line 106 "../src/TabbedWebView.vala"
	_g_object_unref0 (cert);
#line 412 "TabbedWebView.c"
}

gboolean
captive_tabbed_web_view_get_load_cookies (CaptiveTabbedWebView* self)
{
	gboolean result;
#line 22 "../src/TabbedWebView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/TabbedWebView.vala"
	result = self->priv->_load_cookies;
#line 22 "../src/TabbedWebView.vala"
	return result;
#line 425 "TabbedWebView.c"
}

static void
captive_tabbed_web_view_set_load_cookies (CaptiveTabbedWebView* self,
                                          gboolean value)
{
	gboolean old_value;
#line 22 "../src/TabbedWebView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/TabbedWebView.vala"
	old_value = captive_tabbed_web_view_get_load_cookies (self);
#line 22 "../src/TabbedWebView.vala"
	if (old_value != value) {
#line 22 "../src/TabbedWebView.vala"
		self->priv->_load_cookies = value;
#line 22 "../src/TabbedWebView.vala"
		g_object_notify_by_pspec ((GObject *) self, captive_tabbed_web_view_properties[CAPTIVE_TABBED_WEB_VIEW_LOAD_COOKIES_PROPERTY]);
#line 443 "TabbedWebView.c"
	}
}

CaptiveTabbedWebViewSecurity
captive_tabbed_web_view_get_security (CaptiveTabbedWebView* self)
{
	CaptiveTabbedWebViewSecurity result;
#line 23 "../src/TabbedWebView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../src/TabbedWebView.vala"
	result = self->priv->_security;
#line 23 "../src/TabbedWebView.vala"
	return result;
#line 457 "TabbedWebView.c"
}

static void
captive_tabbed_web_view_set_security (CaptiveTabbedWebView* self,
                                      CaptiveTabbedWebViewSecurity value)
{
	CaptiveTabbedWebViewSecurity old_value;
#line 23 "../src/TabbedWebView.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/TabbedWebView.vala"
	old_value = captive_tabbed_web_view_get_security (self);
#line 23 "../src/TabbedWebView.vala"
	if (old_value != value) {
#line 23 "../src/TabbedWebView.vala"
		self->priv->_security = value;
#line 23 "../src/TabbedWebView.vala"
		g_object_notify_by_pspec ((GObject *) self, captive_tabbed_web_view_properties[CAPTIVE_TABBED_WEB_VIEW_SECURITY_PROPERTY]);
#line 475 "TabbedWebView.c"
	}
}

GcrSimpleCertificate*
captive_tabbed_web_view_get_certificate (CaptiveTabbedWebView* self)
{
	GcrSimpleCertificate* result;
	GcrSimpleCertificate* _tmp0_;
#line 24 "../src/TabbedWebView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/TabbedWebView.vala"
	_tmp0_ = self->priv->_certificate;
#line 24 "../src/TabbedWebView.vala"
	result = _tmp0_;
#line 24 "../src/TabbedWebView.vala"
	return result;
#line 492 "TabbedWebView.c"
}

static void
captive_tabbed_web_view_set_certificate (CaptiveTabbedWebView* self,
                                         GcrSimpleCertificate* value)
{
	GcrSimpleCertificate* old_value;
#line 24 "../src/TabbedWebView.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/TabbedWebView.vala"
	old_value = captive_tabbed_web_view_get_certificate (self);
#line 24 "../src/TabbedWebView.vala"
	if (old_value != value) {
#line 506 "TabbedWebView.c"
		GcrSimpleCertificate* _tmp0_;
#line 24 "../src/TabbedWebView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/TabbedWebView.vala"
		_g_object_unref0 (self->priv->_certificate);
#line 24 "../src/TabbedWebView.vala"
		self->priv->_certificate = _tmp0_;
#line 24 "../src/TabbedWebView.vala"
		g_object_notify_by_pspec ((GObject *) self, captive_tabbed_web_view_properties[CAPTIVE_TABBED_WEB_VIEW_CERTIFICATE_PROPERTY]);
#line 516 "TabbedWebView.c"
	}
}

static void
_captive_tabbed_web_view___lambda4_ (CaptiveTabbedWebView* self)
{
#line 74 "../src/TabbedWebView.vala"
	captive_tabbed_web_view_set_security (self, CAPTIVE_TABBED_WEB_VIEW_SECURITY_MIXED_CONTENT);
#line 525 "TabbedWebView.c"
}

static void
__captive_tabbed_web_view___lambda4__webkit_web_view_insecure_content_detected (WebKitWebView* _sender,
                                                                                WebKitInsecureContentEvent event,
                                                                                gpointer self)
{
#line 73 "../src/TabbedWebView.vala"
	_captive_tabbed_web_view___lambda4_ ((CaptiveTabbedWebView*) self);
#line 535 "TabbedWebView.c"
}

static void
_captive_tabbed_web_view___lambda5_ (CaptiveTabbedWebView* self,
                                     WebKitWebView* view,
                                     WebKitLoadEvent event)
{
#line 77 "../src/TabbedWebView.vala"
	g_return_if_fail (view != NULL);
#line 78 "../src/TabbedWebView.vala"
	switch (event) {
#line 78 "../src/TabbedWebView.vala"
		case WEBKIT_LOAD_STARTED:
#line 549 "TabbedWebView.c"
		{
#line 80 "../src/TabbedWebView.vala"
			captive_tabbed_web_view_set_security (self, CAPTIVE_TABBED_WEB_VIEW_SECURITY_LOADING);
#line 81 "../src/TabbedWebView.vala"
			break;
#line 555 "TabbedWebView.c"
		}
#line 78 "../src/TabbedWebView.vala"
		case WEBKIT_LOAD_COMMITTED:
#line 559 "TabbedWebView.c"
		{
#line 83 "../src/TabbedWebView.vala"
			captive_tabbed_web_view_update_tls_info (self);
#line 84 "../src/TabbedWebView.vala"
			break;
#line 565 "TabbedWebView.c"
		}
		default:
#line 78 "../src/TabbedWebView.vala"
		break;
#line 570 "TabbedWebView.c"
	}
}

static void
__captive_tabbed_web_view___lambda5__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                   WebKitLoadEvent load_event,
                                                                   gpointer self)
{
#line 77 "../src/TabbedWebView.vala"
	_captive_tabbed_web_view___lambda5_ ((CaptiveTabbedWebView*) self, _sender, load_event);
#line 581 "TabbedWebView.c"
}

static GObject *
captive_tabbed_web_view_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CaptiveTabbedWebView * self;
	gboolean _tmp0_;
#line 54 "../src/TabbedWebView.vala"
	parent_class = G_OBJECT_CLASS (captive_tabbed_web_view_parent_class);
#line 54 "../src/TabbedWebView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 54 "../src/TabbedWebView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAPTIVE_TYPE_TABBED_WEB_VIEW, CaptiveTabbedWebView);
#line 55 "../src/TabbedWebView.vala"
	_tmp0_ = self->priv->_load_cookies;
#line 55 "../src/TabbedWebView.vala"
	if (_tmp0_) {
#line 603 "TabbedWebView.c"
		gchar* cookies_db_path = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 56 "../src/TabbedWebView.vala"
		_tmp1_ = g_get_user_config_dir ();
#line 56 "../src/TabbedWebView.vala"
		_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, _tmp1_, "epiphany", "cookies.sqlite", NULL);
#line 56 "../src/TabbedWebView.vala"
		cookies_db_path = _tmp2_;
#line 63 "../src/TabbedWebView.vala"
		_tmp3_ = cookies_db_path;
#line 63 "../src/TabbedWebView.vala"
		if (g_file_test (_tmp3_, G_FILE_TEST_IS_REGULAR)) {
#line 618 "TabbedWebView.c"
			WebKitCookieManager* cookie_manager = NULL;
			WebKitNetworkSession* _tmp4_;
			WebKitNetworkSession* _tmp5_;
			WebKitCookieManager* _tmp6_;
			WebKitCookieManager* _tmp7_;
			WebKitCookieManager* _tmp8_;
			WebKitCookieManager* _tmp9_;
			const gchar* _tmp10_;
#line 64 "../src/TabbedWebView.vala"
			_tmp4_ = webkit_web_view_get_network_session ((WebKitWebView*) self);
#line 64 "../src/TabbedWebView.vala"
			_tmp5_ = _tmp4_;
#line 64 "../src/TabbedWebView.vala"
			_tmp6_ = webkit_network_session_get_cookie_manager (_tmp5_);
#line 64 "../src/TabbedWebView.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 64 "../src/TabbedWebView.vala"
			cookie_manager = _tmp7_;
#line 66 "../src/TabbedWebView.vala"
			_tmp8_ = cookie_manager;
#line 66 "../src/TabbedWebView.vala"
			webkit_cookie_manager_set_accept_policy (_tmp8_, WEBKIT_COOKIE_POLICY_ACCEPT_ALWAYS);
#line 67 "../src/TabbedWebView.vala"
			_tmp9_ = cookie_manager;
#line 67 "../src/TabbedWebView.vala"
			_tmp10_ = cookies_db_path;
#line 67 "../src/TabbedWebView.vala"
			webkit_cookie_manager_set_persistent_storage (_tmp9_, _tmp10_, WEBKIT_COOKIE_PERSISTENT_STORAGE_SQLITE);
#line 63 "../src/TabbedWebView.vala"
			_g_object_unref0 (cookie_manager);
#line 649 "TabbedWebView.c"
		} else {
#line 69 "../src/TabbedWebView.vala"
			g_critical ("TabbedWebView.vala:69: No cookies store found, not saving the cookies…");
#line 653 "TabbedWebView.c"
		}
#line 55 "../src/TabbedWebView.vala"
		_g_free0 (cookies_db_path);
#line 657 "TabbedWebView.c"
	}
#line 73 "../src/TabbedWebView.vala"
	g_signal_connect_object ((WebKitWebView*) self, "insecure-content-detected", (GCallback) __captive_tabbed_web_view___lambda4__webkit_web_view_insecure_content_detected, self, 0);
#line 77 "../src/TabbedWebView.vala"
	g_signal_connect_object ((WebKitWebView*) self, "load-changed", (GCallback) __captive_tabbed_web_view___lambda5__webkit_web_view_load_changed, self, 0);
#line 54 "../src/TabbedWebView.vala"
	return obj;
#line 665 "TabbedWebView.c"
}

static void
captive_tabbed_web_view_class_init (CaptiveTabbedWebViewClass * klass,
                                    gpointer klass_data)
{
#line 21 "../src/TabbedWebView.vala"
	captive_tabbed_web_view_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/TabbedWebView.vala"
	g_type_class_adjust_private_offset (klass, &CaptiveTabbedWebView_private_offset);
#line 21 "../src/TabbedWebView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_captive_tabbed_web_view_get_property;
#line 21 "../src/TabbedWebView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_captive_tabbed_web_view_set_property;
#line 21 "../src/TabbedWebView.vala"
	G_OBJECT_CLASS (klass)->constructor = captive_tabbed_web_view_constructor;
#line 21 "../src/TabbedWebView.vala"
	G_OBJECT_CLASS (klass)->finalize = captive_tabbed_web_view_finalize;
#line 21 "../src/TabbedWebView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAPTIVE_TABBED_WEB_VIEW_LOAD_COOKIES_PROPERTY, captive_tabbed_web_view_properties[CAPTIVE_TABBED_WEB_VIEW_LOAD_COOKIES_PROPERTY] = g_param_spec_boolean ("load-cookies", "load-cookies", "load-cookies", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/TabbedWebView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAPTIVE_TABBED_WEB_VIEW_SECURITY_PROPERTY, captive_tabbed_web_view_properties[CAPTIVE_TABBED_WEB_VIEW_SECURITY_PROPERTY] = g_param_spec_enum ("security", "security", "security", CAPTIVE_TABBED_WEB_VIEW_TYPE_SECURITY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/TabbedWebView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAPTIVE_TABBED_WEB_VIEW_CERTIFICATE_PROPERTY, captive_tabbed_web_view_properties[CAPTIVE_TABBED_WEB_VIEW_CERTIFICATE_PROPERTY] = g_param_spec_object ("certificate", "certificate", "certificate", gcr_simple_certificate_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 690 "TabbedWebView.c"
}

static void
captive_tabbed_web_view_instance_init (CaptiveTabbedWebView * self,
                                       gpointer klass)
{
#line 21 "../src/TabbedWebView.vala"
	self->priv = captive_tabbed_web_view_get_instance_private (self);
#line 24 "../src/TabbedWebView.vala"
	self->priv->_certificate = NULL;
#line 701 "TabbedWebView.c"
}

static void
captive_tabbed_web_view_finalize (GObject * obj)
{
	CaptiveTabbedWebView * self;
#line 21 "../src/TabbedWebView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAPTIVE_TYPE_TABBED_WEB_VIEW, CaptiveTabbedWebView);
#line 24 "../src/TabbedWebView.vala"
	_g_object_unref0 (self->priv->_certificate);
#line 21 "../src/TabbedWebView.vala"
	G_OBJECT_CLASS (captive_tabbed_web_view_parent_class)->finalize (obj);
#line 714 "TabbedWebView.c"
}

static GType
captive_tabbed_web_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CaptiveTabbedWebViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) captive_tabbed_web_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CaptiveTabbedWebView), 0, (GInstanceInitFunc) captive_tabbed_web_view_instance_init, NULL };
	GType captive_tabbed_web_view_type_id;
	captive_tabbed_web_view_type_id = g_type_register_static (webkit_web_view_get_type (), "CaptiveTabbedWebView", &g_define_type_info, 0);
	CaptiveTabbedWebView_private_offset = g_type_add_instance_private (captive_tabbed_web_view_type_id, sizeof (CaptiveTabbedWebViewPrivate));
	return captive_tabbed_web_view_type_id;
}

GType
captive_tabbed_web_view_get_type (void)
{
	static volatile gsize captive_tabbed_web_view_type_id__once = 0;
	if (g_once_init_enter (&captive_tabbed_web_view_type_id__once)) {
		GType captive_tabbed_web_view_type_id;
		captive_tabbed_web_view_type_id = captive_tabbed_web_view_get_type_once ();
		g_once_init_leave (&captive_tabbed_web_view_type_id__once, captive_tabbed_web_view_type_id);
	}
	return captive_tabbed_web_view_type_id__once;
}

static void
_vala_captive_tabbed_web_view_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	CaptiveTabbedWebView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAPTIVE_TYPE_TABBED_WEB_VIEW, CaptiveTabbedWebView);
#line 21 "../src/TabbedWebView.vala"
	switch (property_id) {
#line 21 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_LOAD_COOKIES_PROPERTY:
#line 21 "../src/TabbedWebView.vala"
		g_value_set_boolean (value, captive_tabbed_web_view_get_load_cookies (self));
#line 21 "../src/TabbedWebView.vala"
		break;
#line 21 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_PROPERTY:
#line 21 "../src/TabbedWebView.vala"
		g_value_set_enum (value, captive_tabbed_web_view_get_security (self));
#line 21 "../src/TabbedWebView.vala"
		break;
#line 21 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_CERTIFICATE_PROPERTY:
#line 21 "../src/TabbedWebView.vala"
		g_value_set_object (value, captive_tabbed_web_view_get_certificate (self));
#line 21 "../src/TabbedWebView.vala"
		break;
#line 767 "TabbedWebView.c"
		default:
#line 21 "../src/TabbedWebView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/TabbedWebView.vala"
		break;
#line 773 "TabbedWebView.c"
	}
}

static void
_vala_captive_tabbed_web_view_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	CaptiveTabbedWebView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAPTIVE_TYPE_TABBED_WEB_VIEW, CaptiveTabbedWebView);
#line 21 "../src/TabbedWebView.vala"
	switch (property_id) {
#line 21 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_LOAD_COOKIES_PROPERTY:
#line 21 "../src/TabbedWebView.vala"
		captive_tabbed_web_view_set_load_cookies (self, g_value_get_boolean (value));
#line 21 "../src/TabbedWebView.vala"
		break;
#line 21 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_SECURITY_PROPERTY:
#line 21 "../src/TabbedWebView.vala"
		captive_tabbed_web_view_set_security (self, g_value_get_enum (value));
#line 21 "../src/TabbedWebView.vala"
		break;
#line 21 "../src/TabbedWebView.vala"
		case CAPTIVE_TABBED_WEB_VIEW_CERTIFICATE_PROPERTY:
#line 21 "../src/TabbedWebView.vala"
		captive_tabbed_web_view_set_certificate (self, g_value_get_object (value));
#line 21 "../src/TabbedWebView.vala"
		break;
#line 805 "TabbedWebView.c"
		default:
#line 21 "../src/TabbedWebView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/TabbedWebView.vala"
		break;
#line 811 "TabbedWebView.c"
	}
}

